module Operabl
  class Context
    def initialize(params={})
      @branch = :success
      @store = {}
      @result = {}
      @params = params.freeze
    end

    def fail!(_result)
      @branch = :failure
      @result = _result
    end

    def success!(_result)
      @branch = :success
      @result = _result
    end

    def params
      @params
    end

    def [](key)
      @store[key.to_sym]
    end

    def []=(key, value)
      @store[key.to_sym]= value
    end

    def branch
      @branch
    end

    def result
      @result
    end

    def failure?
      @branch == :failure
    end

    def success?
      @branch == :success
    end

  end
end
